(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs'), require('jny-pre-http-services'), require('@angular/common'), require('@angular/forms'), require('primeng/dialog'), require('primeng/button')) :
    typeof define === 'function' && define.amd ? define('jny-user-picker', ['exports', '@angular/core', 'rxjs', 'jny-pre-http-services', '@angular/common', '@angular/forms', 'primeng/dialog', 'primeng/button'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['jny-user-picker'] = {}, global.ng.core, global.rxjs, global.jnyPreHttpServices, global.ng.common, global.ng.forms, global.dialog, global.button));
}(this, (function (exports, i0, rxjs, jnyPreHttpServices, common, forms, dialog, button) { 'use strict';

    var JnyUserPickerService = /** @class */ (function () {
        function JnyUserPickerService() {
            this.dialogAlertSubject = new rxjs.Subject();
        }
        // ===== loginModal (START)=====
        JnyUserPickerService.prototype.sendDialogAlertSubject = function (obj) {
            this.dialogAlertSubject.next(obj);
        };
        JnyUserPickerService.prototype.getDialogAlertSubject = function () {
            return this.dialogAlertSubject.asObservable();
        };
        return JnyUserPickerService;
    }());
    JnyUserPickerService.ɵprov = i0.ɵɵdefineInjectable({ factory: function JnyUserPickerService_Factory() { return new JnyUserPickerService(); }, token: JnyUserPickerService, providedIn: "root" });
    JnyUserPickerService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    JnyUserPickerService.ctorParameters = function () { return []; };

    var JnyUserPickerComponent = /** @class */ (function () {
        function JnyUserPickerComponent(httpService, jnyUserPickerService) {
            this.httpService = httpService;
            this.jnyUserPickerService = jnyUserPickerService;
            this.ctrlUrl = 'osjcEmpCtrl/';
            this.valueChange = new i0.EventEmitter();
            this.userInfo = new i0.EventEmitter();
            this.STORAGE_KEY = 'JNY_loginUser';
            this.selectEmp = {
                userNo: '',
                cname: ''
            };
        }
        JnyUserPickerComponent.prototype.ngOnInit = function () {
        };
        JnyUserPickerComponent.prototype.ngOnChanges = function (changes) {
            if (changes.value.previousValue == null && changes.value.currentValue != null) {
                this.selectEmp.userNo = changes.value.currentValue;
                this.selectEmp.cname = changes.selectEmpName.currentValue;
                this.checkAuth();
            }
        };
        JnyUserPickerComponent.prototype.changeUser = function () {
            if (this.value === '') {
                this.selectEmpName = '';
                this.userInfo.emit({ empNo: '', empName: '' });
            }
        };
        JnyUserPickerComponent.prototype.qryEmp = function (deptNo) {
            return this.httpService.post(this.ctrlUrl + 'qryEmp', deptNo);
        };
        // 挑選部門
        JnyUserPickerComponent.prototype.pickDept = function () {
            var _this = this;
            this.qryEmp(this.selectDept).subscribe(function (carrier) {
                _this.setEmpVos(carrier);
                _this.addAuth();
            }, function (error) { return console.log(error); });
        };
        JnyUserPickerComponent.prototype.pickUser = function (event) {
            this.checkAuth();
        };
        // 查詢目前登入的人是否有此使用者權限
        JnyUserPickerComponent.prototype.checkAuth = function () {
            var _this = this;
            var params = { empNo: this.selectEmp.userNo };
            this.httpService.post('oajcContactCtrl/queryEmpNo', params).subscribe(function (data) {
                _this.setValueEmit(data);
            }, function (error) { console.log(error); });
        };
        JnyUserPickerComponent.prototype.setValueEmit = function (data) {
            this.value = this.selectEmp.userNo;
            this.selectEmpName = this.selectEmp.cname;
            data.attributeMap.contactVO.empNo = this.selectEmp.userNo;
            data.attributeMap.contactVO.empName = this.selectEmp.cname;
            this.visible = false;
            this.valueChange.emit(this.value);
            this.userInfo.emit(data.attributeMap.contactVO);
        };
        // 開啟使用者挑選清單
        JnyUserPickerComponent.prototype.showUserPicker = function () {
            this.queryDeptVOs();
            this.getUserByDept();
            //  this.getUserInfo();
        };
        // 依照部門代碼取得使用者清單
        JnyUserPickerComponent.prototype.getUserByDept = function () {
            var loginUserVO = this.getLoginUser();
            if (this.value != null && this.value !== '') {
                // 使用者輸入欄已有值時，預設將使用者選單選到該選項,部門選單則不選到任何值
                this.selectDept = '';
                this.qryEmpBySameDept(this.value);
            }
            else {
                // 使用者輸入欄無值時，選單預設選到為登入者的部門和職鯿
                this.selectDept = loginUserVO.deptNo;
                this.qryEmpBySameDept(loginUserVO.userId);
            }
            this.visible = true;
        };
        JnyUserPickerComponent.prototype.qryEmpBySameDept = function (empNo) {
            var _this = this;
            this.httpService.post(this.ctrlUrl + 'qryEmpBySameDept', empNo).subscribe(function (carrier) {
                _this.setEmpVos(carrier);
                _this.selectEmp.userNo = empNo;
            }, function (error) { console.error(error); });
        };
        JnyUserPickerComponent.prototype.setEmpVos = function (carrier) {
            var mapArray = carrier.attributeMap['empList'];
            this.empVOs = new Array();
            for (var i = 0; i < mapArray.length; i++) {
                var map = mapArray[i];
                var empVO = new EmpVO();
                empVO.userNo = map['USERNO'];
                empVO.cname = map['CNAME'];
                empVO.deptNo = map['DEPTNO'];
                empVO.hasAuth = '0';
                this.empVOs.push(empVO);
            }
        };
        // empVOs 添加 auth 權限
        JnyUserPickerComponent.prototype.addAuth = function () {
            var auth_list = JSON.parse(sessionStorage.getItem('auth-list'));
            if (auth_list == null) {
                return;
            }
            this.empVOs.forEach(function (mval) {
                auth_list.forEach(function (aval) {
                    if (mval.userNo === aval.empNo) {
                        mval.hasAuth = aval.hasAuth;
                    }
                });
            });
        };
        JnyUserPickerComponent.prototype.queryDeptVOs = function () {
            var _this = this;
            this.httpService.post(this.ctrlUrl + 'qryAllDept').subscribe(function (carrier) {
                var mapArray = carrier.attributeMap['deptList'];
                _this.deptVOs = new Array();
                for (var i = 0; i < mapArray.length; i++) {
                    var map = mapArray[i];
                    var deptVO = new DeptVO();
                    deptVO.deptNo = map['DEPTNO'];
                    deptVO.deptName = map['DEPTNAME'];
                    _this.deptVOs.push(deptVO);
                }
            }, function (error) { return console.log(error); });
        };
        JnyUserPickerComponent.prototype.getLoginUser = function () {
            var loginUserVO = JSON.parse(sessionStorage.getItem(this.STORAGE_KEY));
            if (loginUserVO == null || loginUserVO == undefined) {
                return new LoginUserVO();
            }
            else {
                return loginUserVO;
            }
        };
        return JnyUserPickerComponent;
    }());
    JnyUserPickerComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'lib-jny-user-picker',
                    template: "<style>\r\n  .myBox {\r\n    display: inline-block;\r\n  }\r\n\r\n  .uidText {\r\n    width: 60px;\r\n  }\r\n</style>\r\n\r\n<div class=\"p-inputgroup\">\r\n  <input type=\"text\" pInputText [(ngModel)]=\"value\" (change)=\"changeUser()\" class='uidText'>\r\n  <span class=\"p-inputgroup-addon\">{{selectEmpName}}</span>\r\n  <button type=\"button\" pButton pRipple icon=\"pi pi-user\" styleClass=\"p-button-warn\"\r\n    (click)=\"showUserPicker()\"></button>\r\n</div>\r\n\r\n<p-dialog header=\"\u4F7F\u7528\u8005\u6311\u9078\" [(visible)]=\"visible\" [responsive]=\"true\" [style]=\"{width: '450px', minWidth: '400px'}\"\r\n  [maximizable]=\"true\" [baseZIndex]=\"10000\">\r\n  <div style=\"text-align: center\">\r\n    <div class=\"myBox\">\r\n      <!--\u56E0IE\u4E0B\u62C9\u9078\u55AEoption\u6C92\u6709click\u4E8B\u4EF6\uFF0C\u6545\u5BEB\u5728select\u4E2D-->\r\n      <select [(ngModel)]=\"selectDept\" size=\"20\" (click)=\"pickDept()\" style=\"width:200px\">\r\n        <option *ngFor=\"let deptVO of deptVOs\" [value]=\"deptVO.deptNo\">{{deptVO.deptNo + ' '+ deptVO.deptName}}</option>\r\n      </select>\r\n    </div>\r\n    <div class=\"myBox\" style=\"margin-left:5px\">\r\n      <select [(ngModel)]=\"selectEmp\" size=\"20\" (click)=\"pickUser($event)\" id=\"pickUserSelect\" style=\"width:200px\">\r\n        <option *ngFor=\"let empVO of empVOs\" [ngValue]=\"empVO\">\r\n          <!--[disabled]=\"empVO.hasAuth!=='1'\"-->\r\n          <!--[value]=\"empVO.userNo\"-->\r\n          {{empVO.cname}}\r\n        </option>\r\n      </select>\r\n    </div>\r\n  </div>\r\n</p-dialog>\r\n",
                    providers: []
                },] }
    ];
    JnyUserPickerComponent.ctorParameters = function () { return [
        { type: jnyPreHttpServices.JnyPreHttpServicesService },
        { type: JnyUserPickerService }
    ]; };
    JnyUserPickerComponent.propDecorators = {
        value: [{ type: i0.Input }],
        selectEmpName: [{ type: i0.Input }],
        valueChange: [{ type: i0.Output }],
        userInfo: [{ type: i0.Output }]
    };
    var DeptVO = /** @class */ (function () {
        function DeptVO() {
        }
        return DeptVO;
    }());
    var EmpVO = /** @class */ (function () {
        function EmpVO() {
        }
        return EmpVO;
    }());
    var LoginUserVO = /** @class */ (function () {
        function LoginUserVO() {
            this.tokenId = '';
            this.userId = '';
            this.userName = '';
            this.postId = '';
            this.postName = '';
            this.deptNo = '';
            this.deptName = '';
        }
        return LoginUserVO;
    }());

    var JnyDialogAlertComponent = /** @class */ (function () {
        function JnyDialogAlertComponent(jnyUserPickerService) {
            var _this = this;
            this.jnyUserPickerService = jnyUserPickerService;
            this.display = false;
            this.subscription = this.jnyUserPickerService.getDialogAlertSubject().subscribe(function (obj) {
                _this.display = obj['display'];
                _this.header = obj['header'];
                _this.content = obj['content'];
            });
        }
        JnyDialogAlertComponent.prototype.ngOnInit = function () {
        };
        JnyDialogAlertComponent.prototype.ngOnDestroy = function () {
            this.subscription.unsubscribe();
        };
        return JnyDialogAlertComponent;
    }());
    JnyDialogAlertComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'lib-jny-dialog-alert',
                    template: "<p-dialog [header]=\"header\" [(visible)]=\"display\">\n  {{content}}\n</p-dialog>\n",
                    styles: [""]
                },] }
    ];
    JnyDialogAlertComponent.ctorParameters = function () { return [
        { type: JnyUserPickerService }
    ]; };

    var JnyUserPickerModule = /** @class */ (function () {
        function JnyUserPickerModule() {
        }
        return JnyUserPickerModule;
    }());
    JnyUserPickerModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [JnyUserPickerComponent, JnyDialogAlertComponent],
                    imports: [
                        forms.FormsModule,
                        common.CommonModule,
                        dialog.DialogModule,
                        button.ButtonModule
                    ],
                    exports: [JnyUserPickerComponent, JnyDialogAlertComponent]
                },] }
    ];

    /*
     * Public API Surface of jny-user-picker
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.DeptVO = DeptVO;
    exports.EmpVO = EmpVO;
    exports.JnyDialogAlertComponent = JnyDialogAlertComponent;
    exports.JnyUserPickerComponent = JnyUserPickerComponent;
    exports.JnyUserPickerModule = JnyUserPickerModule;
    exports.JnyUserPickerService = JnyUserPickerService;
    exports.LoginUserVO = LoginUserVO;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=jny-user-picker.umd.js.map
